<?php

// Register the activation hook to install
register_activation_hook( __FILE__, 'usaofcf7_install' );

add_action( 'wpcf7_admin_after_form', 'usaofcf7_setup_form_options' ); 
add_action( 'wpcf7_after_save', 'usaofcf7_save_form' );
add_action( 'wpcf7_before_send_mail', 'usaofcf7_send_sms' );

function usaofcf7_install() {
}

function usaofcf7_setup_form_options( $form ) {
	require_once( plugin_dir_path( __FILE__ ) . '/lib/usaofcf7.php' );
	if ( wpcf7_admin_has_edit_cap() ) {
		$options = get_option( 'usaofcf7_sms_' . $form->id );
		if( empty( $options ) || !is_array( $options ) ) {
			$options = array( 'phone' => '', 'message' => '[your-message]', 'country' => '', 'carrier' => '' );
		}
?>
		<div id="sms-sortables" class="meta-box-sortables ui-sortable">
			
			<div id="maildiv" class="postbox ">
				<div class="handlediv" title="Click to toggle"><br></div>
				<h3 class="hndle"><span>SMS Notifications</span></h3>
				<div class="inside">
					<?php
					if(_isCurl()){
					?>
					<script>
						var usaofcf7_country = new Array();
						var usaofcf7_carrier_msg = new Array();
	<?php
						$usaofcf7_country = getCountryList();
						$usaofcf7_country_default = null;
						foreach ($usaofcf7_country as $country_key => $country_value) {
							if($usaofcf7_country_default == null) {
								$usaofcf7_country_default = $country_key;
							}
	?>
							usaofcf7_country['<?php echo $country_key; ?>'] = new Array();
							usaofcf7_carrier_msg['<?php echo $country_key; ?>'] = new Array();
	<?php
							foreach ($country_value as $carrier_key => $carrier_value) {
	?>
								usaofcf7_country['<?php echo $country_key; ?>'].push('<?php echo $carrier_key ?>');
								
	<?php
								if($carrier_value != null) {
									$msg = '';
									if(isset($carrier_value['note']) && $carrier_value['note'] != '') {
										$msg = $carrier_value['note'];
									}
									if(!$carrier_value['enabled']) {
										$msg .= '<br />In order to access all of the carriers you see here, please visit <a href="http://www.customwpninjas.com/plugin-development/free-sms-add-on-for-contact-form-7/">http://www.customwpninjas.com/plugin-development/free-sms-add-on-for-contact-form-7/</a> For a 1 time fee of $9.99 you can have UNLIMITED free SMS messages to any of the carriers listed above';
									}
	?>
									usaofcf7_carrier_msg['<?php echo $country_key; ?>']['<?php echo $carrier_key ?>'] = '<?php echo $msg ?>';
	<?php
								} else {
	?>
									usaofcf7_carrier_msg['<?php echo $country_key; ?>']['<?php echo $carrier_key ?>'] = '';
	<?php
								}
							}
						}
	?>
						function changeCarrier(country) {
							var sel_country = country.value;
							var sel_carrier = '';
							var carrier_list = '';
							for(var i = 0; i<usaofcf7_country[sel_country].length; i++) {
								if(i == 0) {
									sel_carrier = usaofcf7_country[sel_country][i];
								}
								carrier_list += '<option value="'+usaofcf7_country[sel_country][i]+'">'+usaofcf7_country[sel_country][i]+'</option>';
							}
							document.getElementById('wpcf7-sms-carrier').innerHTML = carrier_list;
							document.getElementById('carrier_note').innerHTML = usaofcf7_carrier_msg[sel_country][sel_carrier];
						}
						function getCarrierNote(carrier) {
							var cn = document.getElementById('wpcf7-sms-country').value;
							if(usaofcf7_carrier_msg[cn]) {
								if(usaofcf7_carrier_msg[cn][carrier.value]) {
									document.getElementById('carrier_note').innerHTML = usaofcf7_carrier_msg[cn][carrier.value];
								} else {
									document.getElementById('carrier_note').innerHTML = '';
								}
							} else {
								document.getElementById('carrier_note').innerHTML = '';
							}
						}
					</script>
					<div class="mail-fields">
						<div class="half-left">
							<div class="mail-field">
								<label for="wpcf7-sms-country">Country:</label><br>
								<select id="wpcf7-sms-country" name="usaofcf7-sms[country]" onchange="changeCarrier(this)">
	<?php
								foreach ($usaofcf7_country as $country_key => $country_value) {
									if($country_key == $options['country']) {
	?>
									<option selected="selected" value="<?php echo $country_key; ?>"><?php echo $country_key; ?></option>
	<?php
									} else {
	?>
									<option value="<?php echo $country_key; ?>"><?php echo $country_key; ?></option>
	<?php
									}
								}
	?>
								</select>
							</div>
							<div class="mail-field">
								<label for="wpcf7-sms-carrier">Carrier:</label><br>
								<select id="wpcf7-sms-carrier" name="usaofcf7-sms[carrier]"  onchange="getCarrierNote(this)">
	<?php
								if($options['country'] == '') {
									$carrier = $usaofcf7_country[$usaofcf7_country_default];
								} else {
									$carrier = $usaofcf7_country[$options['country']];
								}
								$carrier_note = '';
								foreach ($carrier as $carrier_key => $carrier_value) {
									if($carrier_key == $options['carrier']) {
										if($carrier_value != null) {
											$carrier_note = $carrier_value['note'];
										}
	?>
										<option selected="selected" value="<?php echo $carrier_key; ?>"><?php echo $carrier_key; ?></option>
	<?php
									} else {
	?>
										<option value="<?php echo $carrier_key; ?>"><?php echo $carrier_key; ?></option>
	<?php
									}
								}
	?>
								</select>
								<div id="carrier_note" style="color:#FF0000;"><?php echo $carrier_note; ?></div>
							</div>
							<div class="mail-field">
								<label for="wpcf7-sms-recipient">To:</label><br>
								<input type="text" id="wpcf7-sms-recipient" name="usaofcf7-sms[phone]" class="wide" size="70" value="<?php echo $options['phone']; ?>">
							</div>
						</div>
						<div class="half-right">
							<div class="mail-field">
							<label for="wpcf7-mail-body">Message body:</label><br>
							<textarea id="wpcf7-mail-body" name="usaofcf7-sms[message]" cols="100" rows="2"><?php echo $options['message']; ?></textarea>
							</div>
						</div>
						<br class="clear">
						<?php
						} else {
						?>
						PHP cUrl not enabled. Talk to your hosting provider.
						<?php
						}
						?>
					</div>
				</div>
			</div>
		</div>

<?php
	}
}

function usaofcf7_save_form( $form ) {
	require_once( plugin_dir_path( __FILE__ ) . '/lib/usaofcf7.php' );
	if(_isCurl()){
		update_option( 'usaofcf7_sms_' . $form->id, $_POST['usaofcf7-sms'] );
	}
}

function usaofcf7_send_sms( $form ) {
	require_once( plugin_dir_path( __FILE__ ) . '/lib/usaofcf7.php' );
	if(_isCurl()){
		$options = get_option( 'usaofcf7_sms_' . $form->id );
		if( isset( $options['phone'] ) && $options['phone'] != '' && isset( $options['message'] ) && $options['message'] != '' ) {
			
			$message = $form->replace_mail_tags($options['message']);
			$phone = $options['phone'];
			$country = $options['country'];
			$carrier = $options['carrier'];
		
			usaofcf7_send_sms_lib($country, $carrier, $phone, $message);
		}
	}
	
}

